function POD = computePODBasis(model,model_data,Xi,tol)

  tol = eval('tol','1e-6');
  
  POD.Xi = Xi;
  POD.N = size(Xi,2);
  POD.Norm = model_data.h10_inner_product_matrix_reduced;

% compute snapshots
  U = zeros(model_data.ndofs,POD.N);
  for n=1:size(U,2)
    model = model.set_mu(model, Xi(:,n));
    sim_data=detailed_simulation(model,model_data);
    U(:,n)=sim_data.uh.dofs(model_data.dofs);
  end

% compute correlation
  C = U'*POD.Norm*U;
  C = (C+C')/2;
  
% compute eigenvalues and eigenvectors
  [V,Lambda] = eig(C);
  Lambda = abs(diag(Lambda));
  ind = find(Lambda>tol);

% determine d  
  %d = find(~(Lambda>tol),1,'first')-1;
  d = length(ind);  
  
  if ~isempty(d)
  % shrink eigenvalues and eigenvectors 
    V = V(:,ind);
    Lambda = Lambda(ind);
  else
    d = length(Lambda);
  end
  
  POD.d = d;
  
% compute POD basis
  POD.Basis = U*(V*diag(Lambda.^-.5));
  POD.Basis = sqrt(1./size(U,2))*POD.Basis;
  POD.Lambda = Lambda;
  POD.traceC = trace(C);

% compute pre assembled-rhs
  for q=1:size(model_data.operators.b,2)
    POD.operators.b{q} = POD.Basis'*model_data.operators.b{q};
  end
  
% compute pre assembled-lhs
  for q=1:size(model_data.operators.A,2)
    POD.operators.A{q} = POD.Basis'*model_data.operators.A{q}*POD.Basis;
  end
